/*
	Coil Master - A coil inductance calculator.
	Copyright (C) 2010 Hiroyuki Shimada (JQ1WDN). All rights reserved.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	MA 02110-1301 USA
*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <stdexcept>
//---------------------------------------------------------------------------
USEFORM("MainFrm.cpp", MainForm);
USEFORM("ToolFrm.cpp", ToolForm);
USEFORM("ToolSquareFrm.cpp", ToolSquareForm);
USEFORM("LCTankCircuitFrm.cpp", LCTankCircuitForm);
//---------------------------------------------------------------------------
WINAPI _tWinMain(HINSTANCE, HINSTANCE, LPTSTR, int)
{
	try
	{
		Application->Initialize();
		Application->MainFormOnTaskBar = true;
		Application->Title = "Coil Master";
		Application->CreateForm(__classid(TMainForm), &MainForm);
		Application->CreateForm(__classid(TToolForm), &ToolForm);
		Application->CreateForm(__classid(TToolSquareForm), &ToolSquareForm);
		Application->CreateForm(__classid(TLCTankCircuitForm), &LCTankCircuitForm);
		Application->Run();
	}
	catch(Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch(std::exception &exception)
	{
		const String msg = exception.what();
		const String caption = Application->Title;
		const int flag = MB_OK | MB_ICONERROR;

		Application->MessageBox(msg.t_str(), caption.t_str(), flag);
	}
	catch(...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}
	return 0;
}
//---------------------------------------------------------------------------
