//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "LCTankCircuitFrm.h"

#include <cmath>

#include "ShMath.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLCTankCircuitForm *LCTankCircuitForm;
//---------------------------------------------------------------------------
__fastcall TLCTankCircuitForm::TLCTankCircuitForm(TComponent* Owner)
	: TForm(Owner)
{
	this->m_frequency_0 = 0.0;
	this->m_capacitance_1 = 0.0;
	this->m_inductance_2 = 0.0;
}
//---------------------------------------------------------------------------
void __fastcall TLCTankCircuitForm::WMSysCommand(TWMSysCommand& Msg)
{
	switch(Msg.CmdType)
	{
	case SC_MAXIMIZE:
		return;
	}

	TForm::Dispatch(&Msg);
}
//---------------------------------------------------------------------------
void __fastcall TLCTankCircuitForm::WmNCLButtonDblClk(TMessage& Msg)
{
	if(Msg.WParam == HTCAPTION)
	{
		return;
	}

	TForm::Dispatch(&Msg);
}
//---------------------------------------------------------------------------
void __fastcall TLCTankCircuitForm::FormShow(TObject *Sender)
{
	this->PageControl1->TabIndex = 0;
}
//---------------------------------------------------------------------------
// C_N^X̒l擾܂B
double __fastcall TLCTankCircuitForm::GetInductance(
						TEdit *Edit, TComboBox *ComboBox) const
{
	const int miliHenry  = 0;
	const int microHenry = 1;
	const int nanoHenry  = 2;

	double multiplier = 0.0;
	if(ComboBox->ItemIndex == miliHenry)
	{
		multiplier = 1e-3;
	}
	else if(ComboBox->ItemIndex == microHenry)
	{
		multiplier = 1e-6;
	}
	else if(ComboBox->ItemIndex == nanoHenry)
	{
		multiplier = 1e-9;
	}

	const double inductance = Edit->Text.ToDouble() * multiplier;

	return inductance;
}
//---------------------------------------------------------------------------
// LpV^X̒l擾܂B
double __fastcall TLCTankCircuitForm::GetCapacitance(
						TEdit *Edit, TComboBox *ComboBox) const
{
	const int microFarad = 0;
	const int nanoFarad  = 1;
	const int picoFarad  = 2;

	double multiplier = 0.0;
	if(ComboBox->ItemIndex == microFarad)
	{
		multiplier = 1e-6;
	}
	else if(ComboBox->ItemIndex == nanoFarad)
	{
		multiplier = 1e-9;
	}
	else if(ComboBox->ItemIndex == picoFarad)
	{
		multiplier = 1e-12;
	}

	const double capacitance = Edit->Text.ToDouble() * multiplier;

	return capacitance;
}
//---------------------------------------------------------------------------
// Ug̒l擾܂B
double __fastcall TLCTankCircuitForm::GetFrequency(
						TEdit *Edit, TComboBox *ComboBox) const
{
	const int hertz     = 0;
	const int kiloHertz = 1;
	const int megaHertz = 2;

	double multiplier = 0.0;
	if(ComboBox->ItemIndex == hertz)
	{
		multiplier = 1.0;
	}
	else if(ComboBox->ItemIndex == kiloHertz)
	{
		multiplier = 1e3;
	}
	else if(ComboBox->ItemIndex == megaHertz)
	{
		multiplier = 1e6;
	}

	const double frequency = Edit->Text.ToDouble() * multiplier;

	return frequency;
}
//---------------------------------------------------------------------------
// UgvZ܂B
void __fastcall TLCTankCircuitForm::Calc_0_ButtonClick(TObject *Sender)
{
	const double inductance = this->GetInductance(
		this->Inductance_0_Edit, this->InductanceUnit_0_ComboBox);
	const double capacitance = this->GetCapacitance(
		this->Capacitance_0_Edit, this->CapacitanceUnit_0_ComboBox);

	this->m_frequency_0
		= 1.0 / (2.0 * ShMath::PI * std::sqrtl(inductance * capacitance));

	this->FrequencyUnit_0_ComboBoxChange(this);
}
//---------------------------------------------------------------------------
void __fastcall TLCTankCircuitForm::FrequencyUnit_0_ComboBoxChange(TObject *Sender)
{
	const int hertz     = 0;
	const int kiloHertz = 1;
	const int megaHertz = 2;

	double multiplier = 0.0;
	if(this->FrequencyUnit_0_ComboBox->ItemIndex == hertz)
	{
		multiplier = 1.0;
	}
	else if(this->FrequencyUnit_0_ComboBox->ItemIndex == kiloHertz)
	{
		multiplier = 1e-3;
	}
	else if(this->FrequencyUnit_0_ComboBox->ItemIndex == megaHertz)
	{
		multiplier = 1e-6;
	}

	this->Frequency_0_Edit->Text = this->m_frequency_0 * multiplier;
}
//---------------------------------------------------------------------------
// LpV^XvZ܂B
void __fastcall TLCTankCircuitForm::Calc_1_ButtonClick(TObject *Sender)
{
	const double frequency = this->GetFrequency(
		this->Frequency_1_Edit, this->FrequencyUnit_1_ComboBox);
	const double inductance = this->GetInductance(
		this->Inductance_1_Edit, this->InductanceUnit_1_ComboBox);

	this->m_capacitance_1
		= 1.0 / (4.0 * ShMath::PI * ShMath::PI * frequency * frequency * inductance);

	this->CapacitanceUnit_1_ComboBoxChange(this);
}
//---------------------------------------------------------------------------
void __fastcall TLCTankCircuitForm::CapacitanceUnit_1_ComboBoxChange(TObject *Sender)
{
	const int microFarad = 0;
	const int nanoFarad  = 1;
	const int picoFarad  = 2;

	double multiplier = 0.0;
	if(this->CapacitanceUnit_1_ComboBox->ItemIndex == microFarad)
	{
		multiplier = 1e6;
	}
	else if(this->CapacitanceUnit_1_ComboBox->ItemIndex == nanoFarad)
	{
		multiplier = 1e9;
	}
	else if(this->CapacitanceUnit_1_ComboBox->ItemIndex == picoFarad)
	{
		multiplier = 1e12;
	}

	this->Capacitance_1_Edit->Text = this->m_capacitance_1 * multiplier;
}
//---------------------------------------------------------------------------
// C_N^XvZ܂B
void __fastcall TLCTankCircuitForm::Calc_2_ButtonClick(TObject *Sender)
{
	const double frequency = this->GetFrequency(
		this->Frequency_2_Edit, this->FrequencyUnit_2_ComboBox);
	const double capacitance = this->GetCapacitance(
		this->Capacitance_2_Edit, this->CapacitanceUnit_2_ComboBox);

	this->m_inductance_2
		= 1.0 / (4.0 * ShMath::PI * ShMath::PI * frequency * frequency * capacitance);

	this->InductanceUnit_2_ComboBoxChange(this);
}
//---------------------------------------------------------------------------
void __fastcall TLCTankCircuitForm::InductanceUnit_2_ComboBoxChange(TObject *Sender)
{
	const int miliHenry  = 0;
	const int microHenry = 1;
	const int nanoHenry  = 2;

	double multiplier = 0.0;
	if(this->InductanceUnit_2_ComboBox->ItemIndex == miliHenry)
	{
		multiplier = 1e3;
	}
	else if(this->InductanceUnit_2_ComboBox->ItemIndex == microHenry)
	{
		multiplier = 1e6;
	}
	else if(this->InductanceUnit_2_ComboBox->ItemIndex == nanoHenry)
	{
		multiplier = 1e9;
	}

	this->Inductance_2_Edit->Text = this->m_inductance_2 * multiplier;
}
//---------------------------------------------------------------------------

