/*
    Coil Master - A coil inductance calculator.
    Copyright (C) 2010 Hiroyuki Shimada (JQ1WDN). All rights reserved.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    MA 02110-1301 USA
*/
//---------------------------------------------------------------------------

#ifndef MainFrmH
#define MainFrmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <ActnList.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <string>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
protected:
	BEGIN_MESSAGE_MAP
		VCL_MESSAGE_HANDLER(WM_SYSCOMMAND, TWMSysCommand, WMSysCommand);
		VCL_MESSAGE_HANDLER(WM_NCLBUTTONDBLCLK, TMessage, WmNCLButtonDblClk);
	END_MESSAGE_MAP(TForm)
__published:	// IDE Ǘ̃R|[lg
	TLabel *Label3;
	TLabel *Label9;
	TLabel *Label10;
	TLabel *Label11;
	TMainMenu *MainMenu1;
	TActionList *ActionList1;
	TMenuItem *F1;
	TMenuItem *T1;
	TMenuItem *N1;
	TMenuItem *N2;
	TAction *ExitItem;
	TAction *GetTurnFromInductanceItem;
	TAction *GetPitchFromInductanceItem;
	TMenuItem *N3;
	TAction *GetLengthFromInductanceItem;
	TMenuItem *N4;
	TAction *GetRadiusFromInductanceItem;
	TMenuItem *D1;
	TPageControl *PageControl1;
	TTabSheet *TabSheet1;
	TImage *Image1;
	TLabel *Label8;
	TLabel *Label7;
	TGroupBox *GroupBox1;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TLabel *Label14;
	TRadioButton *Turns_0_RadioButton;
	TRadioButton *Pitch_0_RadioButton;
	TEdit *Diamiter_0_Edit;
	TEdit *Length_0_Edit;
	TEdit *Turns_0_Edit;
	TEdit *Pitch_0_Edit;
	TButton *Calc_0_Button;
	TEdit *Inductance_0_Edit;
	TComboBox *Unit_0_ComboBox;
	TTabSheet *TabSheet2;
	TImage *Image2;
	TGroupBox *GroupBox2;
	TLabel *Label12;
	TLabel *Label13;
	TLabel *Label15;
	TLabel *Label16;
	TLabel *Label17;
	TLabel *Label18;
	TRadioButton *Turns_1_RadioButton;
	TRadioButton *Pitch_1_RadioButton;
	TEdit *Side_1_Edit;
	TEdit *Length_1_Edit;
	TEdit *Turns_1_Edit;
	TEdit *Pitch_1_Edit;
	TButton *Calc_1_Button;
	TLabel *Label19;
	TEdit *Inductance_1_Edit;
	TComboBox *Unit_1_ComboBox;
	TLabel *Label20;
	TAction *GetTurnFromInductance_SquareItem;
	TAction *GetPitchFromInductance_SquareItem;
	TAction *GetLengthFromInductance_SquareItem;
	TAction *GetSideFromInductance_SquareItem;
	TMenuItem *N5;
	TMenuItem *T2;
	TMenuItem *P1;
	TMenuItem *L1;
	TMenuItem *S1;
	TAction *LCTankCircuitItem;
	TMenuItem *N6;
	TMenuItem *LCR1;
	void __fastcall Calc_0_ButtonClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall RadioButtons_0_Click(TObject *Sender);
	void __fastcall Unit_0_ComboBoxChange(TObject *Sender);
	void __fastcall ExitItemExecute(TObject *Sender);
	void __fastcall GetTurnFromInductanceItemExecute(TObject *Sender);
	void __fastcall GetPitchFromInductanceItemExecute(TObject *Sender);
	void __fastcall GetLengthFromInductanceItemExecute(TObject *Sender);
	void __fastcall GetRadiusFromInductanceItemExecute(TObject *Sender);
	void __fastcall Calc_1_ButtonClick(TObject *Sender);
	void __fastcall RadioButtons_1_Click(TObject *Sender);
	void __fastcall Unit_1_ComboBoxChange(TObject *Sender);
	void __fastcall GetTurnFromInductance_SquareItemExecute(TObject *Sender);
	void __fastcall GetPitchFromInductance_SquareItemExecute(TObject *Sender);
	void __fastcall GetLengthFromInductance_SquareItemExecute(TObject *Sender);
	void __fastcall GetSideFromInductance_SquareItemExecute(TObject *Sender);
	void __fastcall LCTankCircuitItemExecute(TObject *Sender);

private:	// [U[錾
	double m_inductance;
protected:	// [U[錾
	void __fastcall WMSysCommand(TWMSysCommand& Msg);
	void __fastcall WmNCLButtonDblClk(TMessage& Msg);

	// \mCh: Pʂɍ킹C_N^X̒l𕶎ŕԂ܂B
	virtual std::wstring __fastcall GetInductanceText_0(double inductance) const;
	// \mCh: sb`̒l擾܂B0.0 ȂOX[܂B
	virtual double __fastcall GetPitch_0() const;
	// `fʃRC: Pʂɍ킹C_N^X̒l𕶎ŕԂ܂B
	virtual std::wstring __fastcall GetInductanceText_1(double inductance) const;
	// `fʃRC: sb`̒l擾܂B0.0 ȂOX[܂B
	virtual double __fastcall GetPitch_1() const;

public:		// [U[錾
	__fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
