/*
    Coil Master - A coil inductance calculator.
    Copyright (C) 2010 Hiroyuki Shimada (JQ1WDN). All rights reserved.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    MA 02110-1301 USA
*/
//---------------------------------------------------------------------------
// ܂͑튮Sȉ~ϕsNX̐eNXłB

#ifndef ShCompleteEllipticIntegralH
#define ShCompleteEllipticIntegralH
//---------------------------------------------------------------------------
#include "ShMath.h"
#include "ShSimpsonsRule.h"

template<class T>
class TShCompleteEllipticIntegral
{
protected:
	// ϕ֐ kiK(k) ܂ E(k)jB
	T m_k;

	// ܂͑튮Sȉ~ϕ̔ϕ֐łB
	// 
	//     x : ܂͑튮Sȉ~ϕ̔ϕ֐̈B
	// ߂l
	//     ܂͑튮Sȉ~ϕ̔ϕ֐̖߂lB
	virtual T IntegrateeFunction(T x) = 0;

public:
	// RXgN^
	TShCompleteEllipticIntegral();

	// fXgN^
	virtual ~TShCompleteEllipticIntegral();

	// ܂͑튮Sȉ~ϕs܂B
	// 
	//     k : ܂͑튮Sȉ~ϕ̔ϕ֐̈B
	// ߂l
	//     ܂͑튮Sȉ~ϕ̒lB
	virtual T Integrate(T k, int evenstephen = 100);
};

//---------------------------------------------------------------------------

// RXgN^
template<class T>
TShCompleteEllipticIntegral<T>::TShCompleteEllipticIntegral()
{
}

// fXgN^
template <class T>
TShCompleteEllipticIntegral<T>::~TShCompleteEllipticIntegral()
{
}

// ܂͑튮Sȉ~ϕs܂B
// 
//     k           : ܂͑튮Sȉ~ϕ̔ϕ֐̈B
//     evenstephen : lϕ邩î݁jB
// ߂l
//     ܂͑튮Sȉ~ϕ̒lB
template <class T>
T TShCompleteEllipticIntegral<T>::Integrate(T k, int evenstephen)
{
	this->m_k = k;
	const T x_from = 0.0;
	const T x_to = ShMath::PI / 2.0;
	const int n = evenstephen;

	TShSimpsonsRule<T> simpsonsRule;
	simpsonsRule.SetIntegratee(this->IntegrateeFunction, x_from, x_to, n);
	T answer = simpsonsRule.Integrate();

	return answer;
}

#endif
