/*
    Coil Master - A coil inductance calculator.
    Copyright (C) 2010 Hiroyuki Shimada (JQ1WDN). All rights reserved.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    MA 02110-1301 USA
*/
//---------------------------------------------------------------------------
// 튮Sȉ~ϕsNXłB

#ifndef ShCompleteEllipticIntegral_FirstKindH
#define ShCompleteEllipticIntegral_FirstKindH
//---------------------------------------------------------------------------
#include <cmath>
#include <ShCompleteEllipticIntegral.h>

template<class T>
class TShCompleteEllipticIntegral_FirstKind : public TShCompleteEllipticIntegral<T>
{
protected:
	// 튮Sȉ~ϕ̔ϕ֐łB
	// 
	//     x : 튮Sȉ~ϕ̔ϕ֐̈B
	// ߂l
	//     튮Sȉ~ϕ̔ϕ֐̖߂lB
	virtual T IntegrateeFunction(T x);

public:
	// RXgN^
	TShCompleteEllipticIntegral_FirstKind();

	// fXgN^
	virtual ~TShCompleteEllipticIntegral_FirstKind();
};

//---------------------------------------------------------------------------

// RXgN^
template<class T>
TShCompleteEllipticIntegral_FirstKind<T>::TShCompleteEllipticIntegral_FirstKind()
{
}

// fXgN^
template<class T>
TShCompleteEllipticIntegral_FirstKind<T>::~TShCompleteEllipticIntegral_FirstKind()
{
}

// 튮Sȉ~ϕ̔ϕ֐łB
// 
//     x : 튮Sȉ~ϕ̔ϕ֐̈B
// ߂l
//     튮Sȉ~ϕ̔ϕ֐̖߂lB
template<class T>
T TShCompleteEllipticIntegral_FirstKind<T>::IntegrateeFunction(T x)
{
	return 1.0 / std::sqrtl(1.0 - std::powl(this->m_k * std::sinl(x), 2.0));
}

#endif
